﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;

using  System.Collections.ObjectModel;
using Infragistics.Windows.Controls;

namespace XDG_ComplexObj
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = new ViewModel();
            this.test.RecordFilterDropDownOpening += new EventHandler<Infragistics.Windows.DataPresenter.Events.RecordFilterDropDownOpeningEventArgs>(test_RecordFilterDropDownOpening);
            this.test.RecordFilterDropDownPopulating += new EventHandler<Infragistics.Windows.DataPresenter.Events.RecordFilterDropDownPopulatingEventArgs>(test_RecordFilterDropDownPopulating);
        }

        void test_RecordFilterDropDownPopulating(object sender, Infragistics.Windows.DataPresenter.Events.RecordFilterDropDownPopulatingEventArgs e)
        {
            //throw new NotImplementedException();
            e.IncludeUniqueValues = true;
        }

        private void test_RecordFilterDropDownOpening(object sender, Infragistics.Windows.DataPresenter.Events.RecordFilterDropDownOpeningEventArgs e)
        {
//            FilterDropDownItem    
             //Infragistics.Windows.DataPresenter.FilterDropDownItem filterItem = 

            //for(int i= e.DropDownItems.Count;
            //FilterDropDownItem item = new FilterDropDownItem(new ComparisonCondition(ComparisonOperator.Equals, "Active"), "All Active Tags");

            //FilterDropDownItem filterItem = e.DropDownItems[0] as FilterDropDownItem;
            
            //    filterItem.DisplayText

            Field field = e.Field;

            // RecordManager property returns the record manager associated with the data
            // records that are being filtered. This is especially pertinent with hierarchical
            // data source where multiple child data record collections exist. This lets
            // you know for which data record collection the filter drop-down is being dropped
            // down.
            RecordManager recordManager = e.RecordManager;

            // RaisedForCustomFilterSelectionControl property indicates if the drop-down is 
            // being opened inside the custom filter dialog or within the data presenter itself.
            bool isRaisedFromWithinCustomFilterDialog = e.RaisedForCustomFilterSelectionControl;

            // DropDownItems property returns items that will be displayed in the drop-down.
            // You can manipulate the list and add your own items to it or remove existing 
            // items from it.

            foreach (FilterDropDownItem dropDownItem in e.DropDownItems.ToList())
            {
                if (e.DropDownItems.Count(item => item.DisplayText == dropDownItem.DisplayText) > 1)
                {
                    e.DropDownItems.Remove(dropDownItem);
                }
            }


        }
    }

    public class ViewModel
    {
        public ObservableCollection<RowDetails> DataSource { get; set; }

        public ViewModel()
        {
            DataSource = new ObservableCollection<RowDetails>();

            DataSource.Add(new RowDetails(){ ID=1,CellDetail = new CellDetails() { ProcessValue = "160" ,Description="Desc 1"}});
            DataSource.Add(new RowDetails(){ ID=2,CellDetail= new CellDetails() { ProcessValue = "170", Description = "Desc 2" }});
            DataSource.Add(new RowDetails(){ ID=3,CellDetail= new CellDetails() { ProcessValue = "170", Description = "Desc 3" }});
            DataSource.Add(new RowDetails(){ ID=4,CellDetail = new CellDetails() { ProcessValue = "160", Description = "Desc 1" }});
            DataSource.Add(new RowDetails() { ID = 5, CellDetail = new CellDetails() { ProcessValue = "150", Description = "Desc 2" } });

        }
    }
}
